SystemOrganization addCategory: #Spec!
SystemOrganization addCategory: #'Spec-Examples'!

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 17:27'!
getIndexSelector: aNumber

	getIndexSelector := aNumber! !

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 22:19'!
initialize

	super initialize.
	self initForKeystrokes.! !

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 17:27'!
setIndexSelector: aNumber

	setIndexSelector := aNumber! !

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 16:00'!
update: aSymbol 
	"Refer to the comment in View|update:."

	aSymbol == getListSelector
		ifTrue: [
			self updateList.
			^ super update: aSymbol ].
	aSymbol == getIndexSelector
		ifTrue: [
			self selectionIndex: self getCurrentSelectionIndex.
			^ super update: aSymbol ].
	aSymbol == #allSelections
		ifTrue: [
			self selectionIndex: self getCurrentSelectionIndex.
			self changed.
			^ super update: aSymbol ].! !

!PluggableTextMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 12/14/2011 15:00'!
setStylerClassHolder: aValueHolder

	aValueHolder whenChangedDo: [ self classOrMetaClass: aValueHolder contents ].
	self classOrMetaClass: aValueHolder contents! !

!Morph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/14/2011 16:32'!
addMorphWrapper: aMorphWrapper
	
	
	aMorphWrapper addIn: self.! !

Announcement subclass: #ValueChanged
	instanceVariableNames: 'newContents oldContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ValueChanged commentStamp: '<historical>' prior: 0!
A ValueChanged is an announcement raised when a value of a NewValueHolder is changed!

!ValueChanged class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/28/2011 09:34'!
newContents: newContents

	^ self new
		newContents: newContents;
		yourself! !

!ValueChanged class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/28/2011 09:26'!
oldContents: oldContent newContents: newContent

	^ self new
		newContents: newContent;
		oldContents: oldContent;
		yourself! !

!ValueChanged methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:27'!
newContents: anObject
	
	newContents := anObject! !

!ValueChanged methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:27'!
oldContents: anObject
	
	oldContents := anObject! !

Object subclass: #ComposableModel
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ComposableModel commentStamp: '<historical>' prior: 0!
ComposableModel is an abstract which represent a applicative model made to be composed with other ComposableModel!

ComposableModel subclass: #ButtonComposableModel
	instanceVariableNames: 'actionHolder labelHolder stateHolder enabledHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ButtonComposableModel commentStamp: '<historical>' prior: 0!
A ButtonComposableModel is an applicative model which handle a basic button.

| b |
b:= ButtonComposableModel new.
b openWithSpec.
b labelHolder contents: 'Click me'.

self example!

!ButtonComposableModel classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/15/2011 14:48'!
internSpec

	^ {#PluggableButtonMorph.
	    		#on:getState:action:label:menu:. 	#model. #state. #action. #label. #nil.
			#getEnabledSelector:. 				#enabled.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill}! !

!ButtonComposableModel classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/15/2011 14:42'!
title

	^ 'Button'! !

!ButtonComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/15/2011 14:28'!
action

	self actionHolder contents value! !

!ButtonComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:30'!
actionHolder

	^ actionHolder! !

!ButtonComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:30'!
actionHolder: anObject
	
	actionHolder := anObject! !

!ButtonComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/15/2011 14:48'!
enabled

	^ self enabledHolder contents! !

!ButtonComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:47'!
enabledHolder

	^ enabledHolder! !

!ButtonComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:47'!
enabledHolder: anObject
	
	enabledHolder := anObject.
	anObject whenChangedDo: [ self changed: #enabled ].
	self changed: #enabled! !

!ButtonComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 12/15/2011 14:49'!
initialize
	"Initialization code for ButtonComposableModel"

	super initialize.

	self actionHolder: [] asValueHolder.
	self labelHolder: '' asValueHolder.
	self stateHolder: true asValueHolder.
	self enabledHolder: true asValueHolder.! !

!ButtonComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/15/2011 14:28'!
label

	^ self labelHolder contents! !

!ButtonComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:30'!
labelHolder

	^ labelHolder! !

!ButtonComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:40'!
labelHolder: anObject
	
	labelHolder := anObject.
	anObject whenChangedDo: [ self changed: #label ].
	self changed: #label! !

!ButtonComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/15/2011 14:10'!
state

	^ self stateHolder contents! !

!ButtonComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:30'!
stateHolder

	^ stateHolder! !

!ButtonComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 14:45'!
stateHolder: anObject
	
	stateHolder := anObject.
	anObject whenChangedDo: [ self changed: #state ].
	self changed: #state! !

ComposableModel subclass: #ClassMethodBrowser
	instanceVariableNames: 'listHolder listModel methodModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!ClassMethodBrowser commentStamp: '<historical>' prior: 0!
A ClassMethodBrowser is a simple browser using spec and reusing MethodBrowser to browse classes>>methods>>sourceCode!

!ClassMethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/14/2011 18:07'!
internSpec

	^ { #PanelMorph.
			#changeTableLayout.
			#listDirection:. #bottomToTop.
			#addMorph:. self topSpec.
			#addMorph:. {#model. #methodModel. #textModel. #internSpec.}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!ClassMethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/14/2011 18:12'!
title

	^ 'Class Method Browser'! !

!ClassMethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/14/2011 18:05'!
topSpec

	^{ #PanelMorph.
			#changeTableLayout.
			#listDirection:. #rightToLeft.
			#addMorph:. {#model. #listModel. #internSpec.}.
			#addMorph:. {#model. #methodModel. #listModel. #internSpec.}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!ClassMethodBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 12/15/2011 14:00'!
initialize
	"Initialization code for ClassMethodBrowser"
	| listHolder2 |
	
	super initialize.
	
	listHolder := {} asValueHolder.
	listModel := ListComposableModel new.
	listModel listHolder: listHolder.
	
	methodModel := MethodBrowser new.
	listHolder2 := ComposableValueHolder on: (listModel selectionHolder) do: [:index :selection | selection contents ifNotNil: [:c | c methodDict values sort: [:a :b | a selector < b selector]]].
	methodModel listHolder: listHolder2.
	methodModel listModel wrapHolder contents: [:method | method selector ].
	! !

!ClassMethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 18:03'!
listHolder

	^ listHolder! !

!ClassMethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 18:03'!
listModel

	^ listModel! !

!ClassMethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 18:03'!
methodModel

	^ methodModel! !

ComposableModel subclass: #ClassMethodList
	instanceVariableNames: 'listHolder listModel listModel2 selectionHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!ClassMethodList commentStamp: '<historical>' prior: 0!
| t |
t:= ClassMethodList new.
t openWithSpec.
t listHolder contents: (Smalltalk allClasses).
self example.!

!ClassMethodList classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 21:54'!
internSpec

	^{ #PanelMorph.
			#changeTableLayout.
			#listDirection:. #rightToLeft.
			#addMorph:. {#model. #listModel. #internSpec.}.
			#addMorph:. {#model. #listModel2. #internSpec.}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!ClassMethodList classSide methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 11/17/2011 21:28'!
internSpec2

	^{ #PanelMorph.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	{ 	#model. #listModel. #internSpec.	}.
											#frame:.	(	0@0 corner: 0.5@1)	}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	{ 	#model. #listModel2. #internSpec.	}.
											#frame:.	(	0.5@0 corner: 1@1)	}.
			#hResizing:. 			#spaceFill.
			#vResizing:. 			#spaceFill}! !

!ClassMethodList classSide methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 11/17/2011 19:44'!
miniSpec

	^ { 	#model. #listModel. #windowSpec.	}! !

!ClassMethodList classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 21:56'!
title

	^ 'Class Method List'! !

!ClassMethodList classSide methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 11/17/2011 21:12'!
windowSpec2

	^{ #StandardWindow.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	{ 	#model. #listModel. #windowSpec.	}.
											#frame:.	(	0@0 corner: 0.5@1)	}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	{ 	#model. #listModel2. #windowSpec.	}.
											#frame:.	(	0.5@0 corner: 1@1)	}.
			#title:.					'Test'											}! !

!ClassMethodList methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 12/14/2011 14:50'!
initialize
	| listHolder2 |
	
	super initialize.
	
	listHolder := {} asValueHolder.
	selectionHolder := SelectionValueHolder new.
	
	listModel := ListComposableModel selectionHolder: selectionHolder listHolder: listHolder.
	
	listModel2 := ListComposableModel new.
	listHolder2 := ComposableValueHolder on: (listModel selectionHolder) do: [:index :selection | selection contents ifNotNil: [:c | c methodDict keys sort ]].
	listModel2 listHolder: listHolder2.! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:04'!
listHolder

	^ listHolder! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 22:03'!
listHolder: anObject
	
	listHolder := anObject.
	listModel listHolder: anObject.! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:04'!
listModel

	^ listModel! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:04'!
listModel2

	^ listModel2! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:04'!
listModel2: anObject
	
	listModel2 := anObject! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:04'!
listModel: anObject
	
	listModel := anObject! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:04'!
selectionHolder

	^ selectionHolder! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:04'!
selectionHolder: anObject
	
	selectionHolder := anObject! !

!ComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 21:57'!
internSpec

	^ self subclassresponsibility! !

!ComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 22:07'!
title
	
	^ 'Untitled window'! !

!ComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 22:08'!
windowSpec

	^{ #StandardWindow.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	self internSpec.
											#frame:.	(	0@0 corner: 1@1)	}.
			#title:.					self title}! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/21/2011 14:05'!
buildWithSpec

	^ SpecInterpreter buildMorphFor: self! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:13'!
internSpec

	^ self class internSpec! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 22:21'!
morph

	^ morph! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 22:21'!
morph: anObject
	
	morph := anObject! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/21/2011 13:33'!
openMorphWithSpec

	^ self buildWithSpec openInWorld! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/21/2011 13:36'!
openWithSpec
	| window |

	window := StandardWindow new
					addMorph: self buildWithSpec openInWorld
					frame: (0@0 corner: 1@1).
	window openInWorld.
	^ window! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/21/2011 13:32'!
title

	^ self class title! !

ComposableModel subclass: #DoubleClassMethodList
	instanceVariableNames: 'classMethodList classMethodList2 listHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!DoubleClassMethodList commentStamp: '<historical>' prior: 0!
| t |
t:= DoubleClassMethodList new.
t openWithSpec.
t listHolder contents: (Smalltalk allClasses).
self example!

!DoubleClassMethodList classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 21:58'!
internSpec

	^{ #PanelMorph.
			#changeTableLayout.
			#listDirection:. #bottomToTop.
			#addMorph:. {#model. #classMethodList. #internSpec.}.
			#addMorph:. {#model. #classMethodList2. #internSpec.}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!DoubleClassMethodList classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 22:09'!
title

	^ 'Double double lists'! !

!DoubleClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:51'!
classMethodList

	^ classMethodList! !

!DoubleClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:51'!
classMethodList2

	^ classMethodList2! !

!DoubleClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:51'!
classMethodList2: anObject
	
	classMethodList2 := anObject! !

!DoubleClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:51'!
classMethodList: anObject
	
	classMethodList := anObject! !

!DoubleClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 22:31'!
initialize
	| listHolder2 |


	super initialize.
	classMethodList := ClassMethodList new.
	listHolder := classMethodList listHolder.
	
	classMethodList2 := ClassMethodList new.
	
	listHolder2 := ComposableValueHolder on: (classMethodList selectionHolder) do: [:index :selection | selection contents ifNotNil: [:c | Smalltalk allClasses select:[:e | e category = c category ]]].
	classMethodList2 listHolder: listHolder2! !

!DoubleClassMethodList methodsFor: 'entry point' stamp: 'BenjaminVanRyseghem 11/17/2011 22:04'!
listHolder

	^ listHolder! !

!DoubleClassMethodList methodsFor: 'entry point' stamp: 'BenjaminVanRyseghem 12/14/2011 14:41'!
listHolder: aValueHolder

	listHolder := aValueHolder.
	aValueHolder whenChangedDo: [ classMethodList listHolder contents: aValueHolder contents ].
	classMethodList listHolder contents: aValueHolder contents.! !

ComposableModel subclass: #ListComposableModel
	instanceVariableNames: 'selectionHolder listHolder wrapValueHolder wrapHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ListComposableModel commentStamp: '<historical>' prior: 0!
A ListComposableModel is an applicative model which handle a basic list.

| t |
t:= ListComposableModel new.
t openWithSpec.
t listHolder contents: (Smalltalk allClasses).
self example!

!ListComposableModel class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 12/15/2011 13:29'!
example
	| instance |

	instance := self new.
	instance openWithSpec.
	instance listHolder contents: (Smalltalk allClasses).! !

!ListComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/14/2011 14:36'!
internSpec

	^ {#PluggableListMorph.
	    		#model:. 				#model.
			#getListSelector:. 		#getList.
			#getIndexSelector:. 	#getIndex.
			#setIndexSelector:. 	#setIndex:.
			#wrapSelector:. 		#wrapItem:.
			#hResizing:. 			#spaceFill.
			#vResizing:. 			#spaceFill}! !

!ListComposableModel class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 12/14/2011 14:50'!
selectionHolder: indexHolder listHolder: listHolder

	^ self new
		selectionHolder: indexHolder;
		listHolder: listHolder;
		yourself! !

!ListComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 22:09'!
title

	^ 'List'! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/14/2011 14:50'!
getIndex

	^ self selectionHolder index contents! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 11/7/2011 19:29'!
getList

	^ self listHolder contents! !

!ListComposableModel methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 12/14/2011 14:49'!
initialize

	super initialize.
	self selectionHolder: SelectionValueHolder new.
	self listHolder: Array new asValueHolder.
	self wrapHolder: [:object | object asStringOrText ] asValueHolder! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 17:53'!
listHolder

	^ listHolder! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 17:27'!
listHolder: anObject
	
	listHolder := anObject.
	anObject whenChangedDo: [ self changed: #getList ].
	self changed: #getList! !

!ListComposableModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 12/14/2011 14:49'!
selectionHolder

	^ selectionHolder! !

!ListComposableModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 12/14/2011 14:49'!
selectionHolder: anObject
	
	selectionHolder := anObject.
	anObject whenChangedDo: [ self changed: #getIndex ].
	self changed: #getIndex.! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/14/2011 14:50'!
setIndex: anIndex

	self selectionHolder index contents: anIndex.
	self selectionHolder selection contents: (self getList at: anIndex ifAbsent: [ nil ]).
	self changed: #getIndex! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:20'!
update: aSymbol

	aSymbol = #contents
		ifTrue:[	self changed: #getList ]! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 14:31'!
wrapHolder

	^ wrapHolder! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 14:32'!
wrapHolder: anObject
	
	wrapHolder := anObject.
	anObject whenChangedDo: [ self changed: #getList ].
	self changed: #getList! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/14/2011 14:35'!
wrapItem: anObject

	^ self wrapHolder contents value: anObject! !

ComposableModel subclass: #MethodBrowser
	instanceVariableNames: 'listHolder listModel textModel actionToPerformHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples'!

!MethodBrowser commentStamp: '<historical>' prior: 0!
A MethodBrowser is a simple browser using Spec to display a list of methods and their source code!

!MethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/14/2011 14:47'!
internSpec

	^{ #PanelMorph.
			#changeTableLayout.
			#listDirection:. #bottomToTop.
			#addMorph:. {#model. #listModel. #internSpec.}.
			#addMorph:. {#model. #textModel. #internSpec.}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 13:56'!
actionToPerformHolder

	^ actionToPerformHolder! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 13:57'!
actionToPerformHolder: anHolder

	actionToPerformHolder := anHolder.
	textModel actionToPerformHolder: self actionToPerformHolder.! !

!MethodBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 12/15/2011 13:58'!
initialize
	"Initialization code for MethodBrowser"
	| textHolder behaviorHolder |
	
	super initialize.

	listModel := ListComposableModel new.
	self listHolder: {} asValueHolder.
	
	textHolder := ComposableValueHolder on: (listModel selectionHolder) do: [:index :selection | selection contents 
		ifNil: [ '' ]
		ifNotNil: [:m | m sourceCode ]].
	
	behaviorHolder := ComposableValueHolder on: (listModel selectionHolder) do: [:index :selection | selection contents 
		ifNil: [ nil ]
		ifNotNil: [:m | m methodClass ]].
	
	textModel := TextComposableModel textHolder: textHolder.
	self actionToPerformHolder: [:t | self listModel selectionHolder selection contents inspect ] asValueHolder.
	textModel behaviorHolder: behaviorHolder.
	textModel aboutToStyleHolder contents: [ true ].
	! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 14:39'!
listHolder

	^ listHolder! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 14:42'!
listHolder: anHolder
	
	listHolder := anHolder.
	anHolder whenChangedDo: [ listModel listHolder contents: anHolder contents ].
	listModel listHolder contents: anHolder contents! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 14:51'!
listModel

	^ listModel! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 14:51'!
textModel

	^ textModel! !

ComposableModel subclass: #TextComposableModel
	instanceVariableNames: 'aboutToStyleHolder behaviorHolder textHolder actionToPerformHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!TextComposableModel commentStamp: '<historical>' prior: 0!
A TextComposableModel is an applicative model which handle a basic text.

| t |
t:= TextComposableModel new.
t openWithSpec.
t textHolder contents: 'This is a test'.

self example!

!TextComposableModel classSide methodsFor: 'example' stamp: 'BenjaminVanRyseghem 12/15/2011 13:30'!
example
	| instance |
	
	instance := self new.
	instance openWithSpec.
	instance textHolder contents: 'This is a test'.! !

!TextComposableModel classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/14/2011 15:01'!
internSpec

	^ {#PluggableTextMorph.
	    		#on:text:accept:readSelection:menu:. 	#model. #getText. #accept:. nil. nil.
			#setStylerClassHolder:.				{ #model. #behaviorHolder. }.
			#hResizing:. 							#spaceFill.
			#vResizing:. 							#spaceFill}! !

!TextComposableModel classSide methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 12/13/2011 23:34'!
textHolder: textHolder

	^ self new
		textHolder: textHolder;
		yourself! !

!TextComposableModel classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/13/2011 23:31'!
title

	^ 'Text'! !

!TextComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 13:41'!
aboutToStyleHolder

	^ aboutToStyleHolder! !

!TextComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 13:40'!
aboutToStyleHolder: aValueHolder

	aboutToStyleHolder := aValueHolder.
	aValueHolder whenChangedDo: [ self changed: #getText ].
	self changed: #getText.! !

!TextComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/15/2011 13:52'!
accept: aText

	self textHolder contents: aText.
	self actionToPerformHolder contents value: aText.
	self changed: #clearUserEdits.! !

!TextComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 13:52'!
actionToPerformHolder

	^ actionToPerformHolder! !

!TextComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 13:52'!
actionToPerformHolder: aValueHolder

	actionToPerformHolder := aValueHolder.! !

!TextComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 13:41'!
behaviorHolder

	^ behaviorHolder! !

!TextComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 13:41'!
behaviorHolder: anObject
	
	behaviorHolder := anObject.
	anObject whenChangedDo: [ self changed: #getText ].
	self changed: #getText! !

!TextComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/14/2011 14:17'!
doItContext

	^ nil! !

!TextComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/14/2011 14:17'!
doItReceiver

	^ self selectedBehavior
		ifNil: [ nil ]
		ifNotNil: [:class | class theNonMetaClass ]! !

!TextComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/14/2011 17:26'!
getText
	
	^ self textHolder contents! !

!TextComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 12/15/2011 13:53'!
initialize
	"Initialization code for TextComposableModel"

	super initialize.

	self textHolder: '' asValueHolder.
	self behaviorHolder: nil asValueHolder.
	self aboutToStyleHolder: [ false ] asValueHolder.
	self actionToPerformHolder: [:text | ] asValueHolder.! !

!TextComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 14:09'!
okToStyle

	^ true! !

!TextComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/14/2011 14:14'!
selectedBehavior

	^ self behaviorHolder contents! !

!TextComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/14/2011 14:21'!
shoutAboutToStyle: aMorph
	
	^ self aboutToStyleHolder contents value! !

!TextComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 13:41'!
textHolder

	^ textHolder! !

!TextComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/15/2011 13:41'!
textHolder: anObject
	
	textHolder := anObject.
	anObject whenChangedDo: [ self changed: #getText ].
	self changed: #getText.! !

Object subclass: #MorphWrapper
	instanceVariableNames: 'layout morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!MorphWrapper commentStamp: '<historical>' prior: 0!
A MorphWrapper is used to wrap a morph with a layout in the goal to be easily added to another morph!

!MorphWrapper class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/14/2011 16:27'!
morph: morph layout: layout 

	^ self new
		layout: layout;
		morph: morph;
		yourself! !

!MorphWrapper methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 11/14/2011 16:31'!
addIn: aContainer

	aContainer
		addMorph: morph
		fullFrame: layout! !

!MorphWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/14/2011 16:38'!
frame: relFrame
	| frame |
	frame := LayoutFrame new.
	frame 
		leftFraction: relFrame left; 
		rightFraction: relFrame right; 
		topFraction: relFrame top; 
		bottomFraction: relFrame bottom.
	layout := frame! !

!MorphWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/14/2011 16:38'!
fullFrame: anObject
	
	layout := anObject! !

!MorphWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/14/2011 16:27'!
morph: anObject
	
	morph := anObject! !

Object subclass: #NewValueHolder
	instanceVariableNames: 'announcer contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!NewValueHolder commentStamp: '<historical>' prior: 0!
A NewValueHolder is a new implementation of ValueHolder based on Announcements!

NewValueHolder subclass: #ComposableValueHolder
	instanceVariableNames: 'block originalValueHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ComposableValueHolder commentStamp: '<historical>' prior: 0!
A ComposableValueHolder is a value holder based on another value holder which content is calculated regarding the original value holder content!

!ComposableValueHolder class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
block: block originalValueHolder: originalValueHolder

	^ self new
		block: block;
		originalValueHolder: originalValueHolder;
		yourself! !

!ComposableValueHolder class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
on: originalValueHolder do: block

	^ self new
		block: block;
		originalValueHolder: originalValueHolder;
		yourself! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
block

	^ block! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
block: anObject
	
	block := anObject! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
originalValueHolder

	^ originalValueHolder! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 17:27'!
originalValueHolder: aValueHolder
	
	originalValueHolder := aValueHolder.
	aValueHolder whenChangedSend: #updateContents to: self.
	self update: #update! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:57'!
updateContents

	| args |
	args := self originalValueHolder contents.
	args isArray
		ifTrue: [ self contents: (self block valueWithArguments: args)]
		ifFalse: [ self contents: (self block value: args)].! !

!NewValueHolder class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/28/2011 09:28'!
contents: contents

	^ self new
		contents: contents;
		yourself! !

!NewValueHolder methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 11/28/2011 09:31'!
addDependent: aDependent

	self halt: 'Former API, should be changed'.! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:23'!
contents

	^ contents! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:35'!
contents: anObject
	
	| oldValue |
	oldValue := contents.
	contents := anObject.
	self contentsChanged: oldValue.! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 17:24'!
contentsChanged
	
	announcer announce: (ValueChanged newContents: contents)! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 17:24'!
contentsChanged: oldValue
	
	announcer announce: (ValueChanged oldContents: oldValue newContents: contents)! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 17:24'!
initialize

	super initialize.
	announcer := Announcer new! !

!NewValueHolder methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 11/28/2011 17:25'!
whenChangedDo: aBlock

	announcer on: ValueChanged do: aBlock! !

!NewValueHolder methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 11/28/2011 17:27'!
whenChangedSend: aSelector to: aReceiver

	announcer on: ValueChanged send: aSelector to: aReceiver! !

NewValueHolder subclass: #SelectionValueHolder
	instanceVariableNames: 'index selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!SelectionValueHolder commentStamp: '<historical>' prior: 0!
A SelectionValueHolder is a value holder especially designed to contains a list selection (an index + an object)!

!SelectionValueHolder class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 21:00'!
index: indexValueHolder selection: selectionValueHolder

	^ self new
		index: indexValueHolder;
		selection: selectionValueHolder;
		yourself! !

!SelectionValueHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/17/2011 20:09'!
contents

	^ {index. selection}! !

!SelectionValueHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 20:57'!
index

	^ index! !

!SelectionValueHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 20:59'!
index: anIndex

	index := anIndex.
	self changed: #index! !

!SelectionValueHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/28/2011 17:27'!
initialize

	super initialize.
	index := 0 asValueHolder.
	selection := nil asValueHolder.
	
	index whenChangedSend: #contentsChanged to: self.
	selection whenChangedSend: #contentsChanged to: self.! !

!SelectionValueHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 20:57'!
selection

	^ selection! !

!SelectionValueHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 20:58'!
selection: aSelection

	selection := aSelection.
	self changed: #selection! !

!Object methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/28/2011 09:29'!
asValueHolder

	^ NewValueHolder contents: self! !

!Object methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 20:47'!
update: aParameter 
	"Receive a change notice from an object of whom the receiver is a 
	dependent. The default behavior is to do nothing; a subclass might want 
	to change itself in some way."

	self triggerEvent: #changed.
	^ self! !

Object subclass: #SpecInterpreter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!SpecInterpreter commentStamp: '<historical>' prior: 0!
#model is a magic world to swap the symbol to the model object
!

!SpecInterpreter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/17/2011 21:42'!
buildMorphFor: aComposableModel
	
	^ self interpretASpec: aComposableModel class internSpec model: aComposableModel! !

!SpecInterpreter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/17/2011 21:42'!
buildWindowFor: aComposableModel
	
	^ self interpretASpec: aComposableModel class windowSpec model: aComposableModel! !

!SpecInterpreter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/8/2011 14:26'!
classKeys

	^ Smalltalk keys! !

!SpecInterpreter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 17:09'!
convertSymbolOfClassToInstance: aSymbol

	^ (Smalltalk at: aSymbol) new! !

!SpecInterpreter class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 12/21/2011 13:24'!
interpretASpec: aSpec model: aModel
	| instance index |

	aSpec ifNil: [ ^ nil ].
	(aSpec isCollection and: [aSpec isSequenceable]) ifFalse: [ ^ aSpec ].
	aSpec isString ifTrue: [ 
			^ aSpec == #model
				ifTrue: [ aModel ]
				ifFalse: [ 
					(self classKeys identityIncludes: aSpec)
						ifTrue: [ self convertSymbolOfClassToInstance: aSpec ]
						ifFalse: [ aSpec ]]].

	" aSpec is an Array "
	instance := self interpretASpec: aSpec first model: aModel.
	
	index := 2.	
	
	[ index <= aSpec size ]
		whileTrue: [ | selector numArgs args newInstance result |
			selector := aSpec at: index.
			numArgs := selector numArgs.
			args := aSpec copyFrom: index + 1 to: index + numArgs.
			args := args collect: [:each | self interpretASpec: each model: aModel].
			index := index + numArgs + 1.
			newInstance := instance perform: selector withArguments: args.
			index > aSpec size
				ifTrue: [
					aModel morph: instance.
					^ self interpretASpec: newInstance model: instance ].
			instance := newInstance].
	self halt.
	^ instance! !
